// 公共函数库
var app = getApp()
const qiniuUploader = require("./qiniuUploader.js");
class Base {
	constructor() {
		// this.baseUrl = 'https://wandoutiyu.xueyoubangedu.com/api/' //线上接口
		this.baseUrl = 'https://wandoutiyu.test.xueyoubangedu.com/api/' //测试接口
	}
	newRequest(params, flag = false, tips = true) {	
		let that = this
		if (!params.type) {
			params.type = 'GET'
		}
		var cur_url = that.baseUrl + params.url
		wx.request({
			url: cur_url,
			data: params.data,
			method: params.type,
			header: {
				'token': app.globalData.token,
				'app': 'coach'
			},
			success: function (res) {
				params.ischeckedCallback && params.ischeckedCallback() //防止用户多次点击，请求完成后让用户可点
				if (wx.showLoading()) {
					wx.hideLoading() //隐藏加载动画
				}
				if (res.statusCode == 200) {
					let rstcode = res.data.meta.code.toString() //接口返回的错误码
					if (rstcode == '200') {
						params.callback && params.callback(res.data.data, res) // 请求成功 
					} else if (rstcode == '400') {
						if (!flag) {
							app.getSessionKey(function () {
								that.newRequest(params, true, tips)
							})
						}
					} else if (rstcode == '404') {
						wx.showModal({
							title: '错误',
							content: '网络请求失败'
						})
					} else {
						params.confirmback && params.confirmback(res) // 错误回调 
						if (tips) {
							wx.showToast({
								title: res.data.meta.msg,
								icon: 'none',
								duration: 2000
							})
						}
					
					}
				} else {
					if (wx.showLoading()) {
						wx.hideLoading() //隐藏加载动画
					}
					wx.showModal({
						title: '错误',
						content: '网络请求失败'
					})
				}
			}
		})
	}

	//富文本
	richText(detail) {
		if (detail != '' && detail != null && detail != undefined) {
			var newDetail = '';
			newDetail = detail.replace(/\<[\/]?(section)/g, function (m, m1) {
				return m.replace('section', 'div')
			});
			newDetail = newDetail.replace(/\<[\/]?(ruby)/g, function (m, m1) {
				return m.replace('ruby', 'span')
			});
			newDetail = newDetail.replace(/\<[\/]?(rt)/g, function (m, m1) {
				return m.replace('rt', 'span')
			});
			newDetail = newDetail.replace(/\<[\/]?(rp)/g, function (m, m1) {
				return m.replace('rp', 'span')
			});
			newDetail = newDetail.replace(/\<[\/]?(video)/g, function (m, m1) {
				return m.replace('video', 'video')
			});
			newDetail = newDetail.replace(/(\<img)/g, '$1 class="hellorich"');
			newDetail = newDetail.replace(/(\<div)/g, '$1 class="hellorich"');
			newDetail = newDetail.replace(/(\<p)/g, '$1 class="hellorich"');
			newDetail = newDetail.replace(/(\<video)/g, '$1 class="helloVideo"');

			return newDetail;
		} else {
			return ''
		}
	}


	trimStrSpace(str) {
		return str.replace(/(^\s*)|(\s*$)/g, '')
	}


	/**
	 * 提示框
	 * icon [success,loading,none]
	 */
	toast(
		title,
		icon = 'none',
		duration = 2000,
		mask = true,
		callback
	) {
		wx.showToast({
			title: title,
			icon: icon,
			duration: duration,
			mask: mask,
			success: function () {
				callback && callback()
			}
		})
	}

	goBack(num) {
		var pages = getCurrentPages()
		var prevPage = pages[pages.length - parseInt(num)]
		prevPage.setData({
			isrefresh: true
		})
		setTimeout(function () {
			wx.navigateBack({
				delta: parseInt(num-1)
			})
		}, 800)
	}

	//七牛上传
	initQiniu() {
		var options = {
		  uptokenURL: 'https://wandoutiyu.test.xueyoubangedu.com/api/get_upload_token',
		  domain: 'https://wandoutiyu.test.xueyoubangedu.com/',
		  uploadURL: 'https://up-z1.qiniup.com'
		};
		qiniuUploader.init(options);
	}
	
}

export {
	Base
}